#include <stdio.h>
#include <stdlib.h>
#include "fxlib.h"
#include "MonochromeLib.h"
#include "fonctions basiques.h"
#include "Ether.h"


void magasin(Donnees *donnees,Pouvoir pouvoirs[NOMBRE_POUVOIRS],Pouvoir *pouvoirs_choisis[6],char *larmes)
{
	Pouvoir *selection=pouvoirs;

	while(ALPHA)Sleep(100);
	
	while(!ALPHA)
	{
		affichage_magasin(pouvoirs,pouvoirs_choisis,selection,larmes);
		
		if(!donnees->visite_magasin)
		{
			premiere_visite_magasin();
			donnees->visite_magasin=VRAI;
		}		
		
		selection=deplacement_curseur(pouvoirs,selection);
		pouvoirs_choisis[selection->type_energie]=gestion_shift(selection,pouvoirs_choisis[selection->type_energie],larmes);
		if(IsKeyDown(KEY_CTRL_OPTN))informations(selection);
		Sleep(120);
	}
	
	while(ALPHA)Sleep(100);
}

Pouvoir *gestion_shift(Pouvoir *selection,Pouvoir *pouvoir_selectionne,char *larmes)
{
	if(SHIFT)
	{
		if(selection->acquis)pouvoir_selectionne=selection;
		else
		{
			if(*larmes>=selection->cout)
			{
				*larmes-=selection->cout;
				selection->acquis=VRAI;
			}
		}		
	}
	
	while(SHIFT)Sleep(100);
	return pouvoir_selectionne;
}

void informations(Pouvoir *selection)
{
	char i,j,y,chaine1[120]="ENERGIE ",chaine2[6][15]={"VIBRATILE","METAPHYSIQUE","TRANSCENDANTE","RESIDUELLE","CHAOTIQUE","PSYCHIQUE"};
	char description[NOMBRE_POUVOIRS][120]={
		"Reduit la precision des/ennemis environnants",
		"Repand de la fumee qui/desoriente les ennemis",
		"Envoie une onde de choc/qui expulse les ennemis/environnants en leur/infligeant des degats",
		"Vous rend invisible/pendant un court instant",
		"Vous permet de traverser/les ennemis. Utile si vous/etes encercle",
		"Vous rend indetectable/pendant une longue duree,/a condition de ne pas vous/approcher de vos ennemis.",
		"Augmente considerablement/votre vitesse",
		"Renvoie contre vos/ennemis la moitie des/degats qu'ils vous/infligent",
		"Permet de regagner vos/points de vie/progressivement tant que/vous etes immobile",
		"Detecte une source/d'energie et l'utilise pour/lancer une decharge a un/ennemi proche",
		"Detecte une source/d'energie et la sacrifie en/causant une puissante/explosion",
		"Detecte une source/d'energie et l'utilise pour/vous soigner. Plus la/source est proche et plus/l'effet est important",
		"Cree devant vous un mur/resistant, long a detruire",
		"Cree une copie passive de/vous-meme pour tromper/les ennemis",
		"Reconfigure aleatoirement/votre position et celle de/vos ennemis dans la salle",
		"Assome les ennemis, les/rendant temporairement/inactifs",
		"Frappe un ennemi de folie,/qui devient hostile a tout/le monde",
		"Repand la confusion chez/les ennemis, rendant/leurs deplacements/anarchiques"};

	PopUpWin(6);
	affichage_pouvoir(12,6,selection->id);
	if(selection->acquis)ML_filled_circle(16,10,5,ML_XOR);
	else ML_circle(16,10,5,ML_BLACK);
	
	PrintMini(25,5,CUC selection->nom,1);
	PrintMini(25,11,CUC strcat(chaine1,chaine2[selection->type_energie]),1);
	
	strcpy(chaine1,CUC description[selection->id]);
	y=20;
	j=0;
	for(i=0;chaine1[i];i++)
	{
		if(chaine1[i+1]=='/' || !chaine1[i+1])
		{
			chaine1[i+1]=0;
			PrintMini(11,y,CUC chaine1+j,1);
			i++;
			j=i+1;
			y+=6;
		}
	}
	
	PrintMini(64,53,CUC "EXIT : retour",1);
	ML_display_vram();
	
	while(!EXIT)Sleep(100);
}

Pouvoir *deplacement_curseur(Pouvoir pouvoirs[NOMBRE_POUVOIRS],Pouvoir *selection)
{
	char i,j=100,x,y;
	int direction=HAUT+2*DROITE+3*BAS+4*GAUCHE;
	short distanceX,distanceX_min=1000,distanceY,distanceY_min=1000;
	
	for(i=0;i<NOMBRE_POUVOIRS;i++)
	{
		x=(pouvoirs[i]).x;
		y=(pouvoirs[i]).y;
		
		if(&pouvoirs[i]!=selection && (pouvoirs[i]).disponible && ((y<selection->y && direction==1) || (x>selection->x && direction==2) || (y>selection->y && direction==3) || (x<selection->x && direction==4)))
		{
			distanceX=ABS(selection->x - x);
			distanceY=ABS(selection->y - y);
			
			if((distanceX<distanceX_min && !(direction&1)) || (distanceY<distanceY_min && x==selection->x && direction&1) || (distanceX==distanceX_min && distanceY<=distanceY_min && !(direction&1)))
			{
				j=i;
				distanceX_min=distanceX;
				distanceY_min=distanceY;
			}
		}
	}

	if(j!=100)return &pouvoirs[j];
	else return selection;
}

void affichage_magasin(Pouvoir pouvoirs[NOMBRE_POUVOIRS],Pouvoir *pouvoirs_choisis[6],Pouvoir *selection,char *larmes)
{
	char condition,i,chaine1[]="  larme ",chaine2[12];
	Pouvoir *pouvoir;
	
	ML_clear_vram();

	for(i=0;i<NOMBRE_POUVOIRS;i++)
	{
		condition=0;
		pouvoir=&pouvoirs[i];
		pouvoir->disponible=FAUX;
		
		if(pouvoir->preRequis1)
		{
			if(pouvoir->preRequis1->acquis)condition++;
		}
		else condition++;
		if(pouvoir->preRequis2)
		{
			if(pouvoir->preRequis2->acquis)condition++;
		}
		else condition++;

		if(condition==2)
		{
			affichage_pouvoir(pouvoir->x-4,pouvoir->y-4,pouvoir->id);
		
			if(pouvoir->acquis)ML_filled_circle(pouvoir->x,pouvoir->y,5,ML_XOR);
			else ML_circle(pouvoir->x,pouvoir->y,5,ML_BLACK);
			
			if(pouvoir==selection)
			{
				if(pouvoir->acquis)ML_circle(pouvoir->x,pouvoir->y,5,ML_WHITE);
				ML_circle(pouvoir->x,pouvoir->y,6,ML_BLACK);
			}
			
			pouvoir->disponible=VRAI;
		}
	}
	
	ML_vertical_line(85,0,63,ML_BLACK);
	ML_vertical_line(87,0,63,ML_BLACK);
	
	if(pouvoirs_choisis[selection->type_energie]!=selection)
	{
		PrintMini(89,13,CUC "SHIFT :",1);
		if(selection->acquis)PrintMini(93,19,CUC "Activer",1);
	}
	
	if(!selection->acquis)
	{
		PrintMini(89,1,CUC "Cout :",1);
		chaine1[0]='0'+selection->cout;
		if(selection->cout==1)chaine1[7]=0;
		else chaine1[7]='s';
		PrintMini(93,7,CUC chaine1,1);
		PrintMini(93,19,CUC "Acheter",1);
	}
	
	PrintMini(89,25,CUC "OPTN :",1);
	PrintMini(93,31,CUC "Infos",1);
	
	PrintMini(89,37,CUC "Stock :",1);
	PrintMini(93-2*(*larmes>9),43,CUC convert(chaine2,*larmes),1);
	PrintMini(101,43,CUC "larme",1);
	if(*larmes>1)PrintMini(124,43,CUC "s",1);
	
	if(pouvoirs_choisis[selection->type_energie])
	{
		affichage_pouvoir(104,53,pouvoirs_choisis[selection->type_energie]->id);
		ML_filled_circle(108,57,5,ML_XOR);
	}	
	affichage_icone(89,53,selection->type_energie,pouvoirs_choisis[selection->type_energie]==selection);
	
	
	ML_display_vram();
}


void affichage_pouvoir(char x,char y,char id)
{
	char bitmap[NOMBRE_POUVOIRS][18]={
		{0x0, 0x7f, 0x8, 0x7f, 0xb, 0x7f, 0xc, 0x7f, 0x18, 0x7f, 0x68, 0x7f, 0x1c, 0x7f, 0x8, 0x7f, 0x0, 0x7f},		//Aura d'entrave
		{0x0, 0x7f, 0x2a, 0x7f, 0x55, 0x7f, 0x2a, 0x7f, 0x55, 0x7f, 0x2a, 0x7f, 0x55, 0x7f, 0x2a, 0x7f, 0x0, 0x7f},		//Ecran de fumée
		{0x0, 0x7f, 0x0, 0x7f, 0x0, 0x7f, 0x80, 0xff, 0xa2, 0xff, 0xaa, 0xff, 0x0, 0x7f, 0x0, 0x7f, 0x0, 0x7f},		//Impulsion
		{0x0, 0x7f, 0x0, 0x7f, 0x8, 0x7f, 0x0, 0x7f, 0x22, 0x7f, 0x0, 0x7f, 0x8, 0x7f, 0x0, 0x7f, 0x0, 0x7f},		//Fugacite
		{0x10, 0x7f, 0x44, 0x7f, 0x21, 0x7f, 0x8, 0x7f, 0x41, 0x7f, 0x22, 0x7f, 0x14, 0x7f, 0x8, 0x7f, 0x0, 0x7f},		//Vaporisation
		{0x0, 0x7f, 0x1c, 0x7f, 0x3e, 0x7f, 0x6b, 0x7f, 0x7f, 0x7f, 0x3e, 0x7f, 0x1c, 0x7f, 0x8, 0x7f, 0x0, 0x7f},		//Furtivite
		{0x0, 0x7f, 0x0, 0x7f, 0x22, 0x7f, 0xf7, 0x7f, 0x8, 0xff, 0xf7, 0x7f, 0x22, 0x7f, 0x0, 0x7f, 0x0, 0x7f},		//Véhémence	
		{0x0, 0x7f, 0x34, 0x7f, 0x3f, 0x7f, 0x34, 0x7f, 0x30, 0x7f, 0x32, 0x7f, 0x3f, 0x7f, 0x32, 0x7f, 0x0, 0x7f},		//Bouclier
		{0x0, 0x7f, 0x1c, 0x7f, 0x22, 0x7f, 0x49, 0x7f, 0x5d, 0x7f, 0x49, 0x7f, 0x22, 0x7f, 0x14, 0x7f, 0x8, 0x7f},		//Regénération
		{0x0, 0x7f, 0x1, 0x7f, 0x2, 0xff, 0x1, 0x7f, 0x4, 0x7f, 0x8, 0x7f, 0x10, 0x7f, 0x20, 0x7f, 0x0, 0x7f},		//Décharge d'énergie
		{0x20, 0x7f, 0x1a, 0x7f, 0x5, 0x7f, 0x32, 0x7f, 0xc9, 0x7f, 0x15, 0x7f, 0x24, 0xff, 0x48, 0x7f, 0x8, 0x7f},		//Déflagration
		{0x0, 0x7f, 0x8, 0x7f, 0x22, 0x7f, 0x8, 0x7f, 0x55, 0x7f, 0x8, 0x7f, 0x22, 0x7f, 0x8, 0x7f, 0x0, 0x7f},			//Ressourcement
		{0x0, 0x7f, 0x8, 0x7f, 0x41, 0x7f, 0x0, 0x7f, 0x3e, 0x7f, 0xbe, 0xff, 0x3e, 0x7f, 0x0, 0x7f, 0x0, 0x7f},		//Rempart d'énergie
		{0x8, 0x7f, 0x41, 0x7f, 0x1c, 0x7f, 0x22, 0x7f, 0xb6, 0xff, 0x22, 0x7f, 0x14, 0x7f, 0x49, 0x7f, 0x0, 0x7f},		//Leurre
		{0xc, 0x7f, 0x10, 0x7f, 0x22, 0x7f, 0x95, 0x7f, 0x80, 0xff, 0x54, 0xff, 0x22, 0x7f, 0x4, 0x7f, 0x18, 0x7f},		//Tourbillon chaotique
		{0x28, 0x7f, 0x2, 0x7f, 0x10, 0x7f, 0x40, 0xff, 0x3e, 0x7f, 0x36, 0x7f, 0x22, 0x7f, 0x36, 0x7f, 0x36, 0x7f},		//Etourdissement
		{0x0, 0x7f, 0x0, 0x7f, 0x22, 0x7f, 0x14, 0x7f, 0x0, 0x7f, 0x1c, 0x7f, 0x22, 0x7f, 0x0, 0x7f, 0x0, 0x7f},		//Démence
		{0x0, 0x7f, 0x1c, 0x7f, 0x22, 0x7f, 0x22, 0x7f, 0x4, 0x7f, 0x8, 0x7f, 0x8, 0x7f, 0x0, 0x7f, 0x8, 0x7f}};		//Confusion
	
	ML_bmp_or(CUC bitmap[id],x,y,9,9);
}

void affichage_icone(char x,char y,char numero,Bool negatif)
{
	//x=89	y=53

	char chaine[]="F1";
	chaine[1]+=numero;
	PrintMini(x+2,y+2,CUC chaine,1);
	
	ML_horizontal_line(y,x+1,x+9,ML_BLACK);
	ML_vertical_line(x,y+1,y+7,ML_BLACK);
	ML_vertical_line(x+10,y+1,y+7,ML_BLACK);
	ML_horizontal_line(y+8,x+1,x+9,ML_BLACK);
	if(negatif)ML_rectangle(x+1,y+1,x+9,y+7,0,0,ML_XOR);	
}