#include <stdio.h>
#include <stdlib.h>
#include "fxlib.h"
#include "MonochromeLib.h"
#include "fonctions basiques.h"
#include "Ether.h"

/*
	Contenu du fichier de sauvegarde :
	-> structure Donnees
	-> structure General
	-> structure Map
*/

int AddIn_main(int isAppli, unsigned short OptionNum)
{
	char larme[]={0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x2, 0x80, 0x4, 0x40, 0x8, 0xa0, 0x8, 0xa0, 0x9, 0x20, 0x4, 0x40, 0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0},curseur=0;
	int fichier=0;
	Bool confirmation;
	unsigned int key;
	FONTCHARACTER nom_fichier[20]={'\\','\\','f','l','s','0','\\','E','T','H','E','R','.','s','a','v',0};

	srand(RTC_getTicks());
	fichier=Bfile_OpenFile(nom_fichier,_OPENMODE_READ);
	if(fichier<0)fichier=0;
	
	do
	{	do
		{
			ML_clear_vram();
			affichage_fond_ecran();
			if(!fichier)ML_rectangle(29,40,98,48,0,ML_WHITE,ML_WHITE);
			
			ML_bmp_16_or((const unsigned short*) larme,15,26+11*curseur);
			ML_bmp_16_or((const unsigned short*) larme,98,26+11*curseur);
			
			GetKey(&key);
			do
			{
				curseur+=(key==KEY_CTRL_DOWN)-(key==KEY_CTRL_UP);
			}while(curseur==1 && !fichier);
			curseur+=(curseur<0)-(curseur>2);
		}while(key!=KEY_CTRL_EXE);
		
		confirmation=VRAI;
		if(!curseur && fichier)
		{
			PopUpWin(5);
			PrintMini(11,5,CUC "Attention, une partie",1);
			PrintMini(11,11,CUC "existe deja. Elle sera",1);
			PrintMini(11,17,CUC "perdue si vous sauvegardez",1);
			PrintMini(11,23,CUC "la nouvelle.",1);
			PrintMini(11,29,CUC "Continuer quand meme ?",1);
			PrintMini(11,45,CUC "F1 : oui",1);
			PrintMini(84,45,CUC "F6 : non",1);
			ML_display_vram();
			
			while(IsKeyUp(KEY_CTRL_F1) && IsKeyUp(KEY_CTRL_F6))Sleep(100);
			confirmation=IsKeyDown(KEY_CTRL_F1);
			while(IsKeyDown(KEY_CTRL_F1))Sleep(100);
		}

		if(curseur<2 && confirmation)
		{
			fichier=jeu(fichier,curseur);
			curseur=0;
		}
		
	}while(curseur!=2);
	if(fichier)Bfile_CloseFile(fichier);
}

void affichage_fond_ecran()
{
	//On passe par une fonction à part pour éviter de pomper trop de RAM
	char fond_ecran[]={0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
					   0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xff, 0xfc, 0x3, 0xff, 0xfe, 0x1, 0xf8, 0x3f, 0x0, 0xff, 0xff, 0x80, 0x7f, 0xff, 0x80,
					   0xc, 0x0, 0x6, 0x6,0x0, 0x3, 0x3, 0x8, 0x21, 0x81, 0x80, 0x0, 0xc0, 0xc0, 0x1, 0xc0, 0xb, 0xff, 0xfe, 0x5, 0xff, 0xff, 0x2,
					   0xf8, 0x3f, 0x81, 0x7f, 0xff, 0xc0, 0xbf,0xff, 0xe0, 0xb, 0xff, 0xfe, 0x5, 0xff, 0xff, 0x2, 0xf8, 0x3f, 0x81, 0x7f, 0xff, 0xc0,
					   0xbf, 0xff, 0xe0, 0xb, 0xfe, 0x0, 0x7, 0xff, 0xff, 0x2,0xf8, 0x3f, 0x81, 0x7f, 0xc0, 0x0, 0xbf, 0x7, 0xe0, 0xb, 0xfc, 0x0, 0x0,
					   0x3f, 0xe0, 0x2, 0xf8, 0x3f, 0x81, 0x7f, 0x80, 0x0, 0xbf, 0x3, 0xe0, 0xb,0xfc, 0x0, 0x0, 0x1f, 0xc0, 0x2, 0xfc, 0x7f, 0x81, 0x7f,
					   0x80, 0x0, 0xbf, 0x1, 0xe0, 0xb, 0xfc, 0x0, 0x0, 0x1f, 0xc0, 0x2, 0xff, 0xff, 0x81, 0x7f,0x80, 0x0, 0xbf, 0x1, 0xe0, 0xb, 0xfe,
					   0x0, 0x0, 0x1f, 0xc0, 0x2, 0xff, 0xff, 0x81, 0x7f, 0xc0, 0x0, 0xbf, 0x1, 0xe0, 0xb, 0xff, 0xfc, 0x0, 0x1f, 0xc0, 0x2, 0xff, 
					   0xff, 0x81, 0x7f, 0xff, 0x80, 0xbf, 0x3, 0xe0, 0xb, 0xff, 0xfe, 0x0, 0x1f, 0xc0, 0x2, 0xff, 0xff, 0x81, 0x7f, 0xff, 0xc0, 0xbf,
					   0x7, 0xe0, 0xb, 0xff, 0xfe, 0x0, 0x1f, 0xc0, 0x2, 0xff, 0xff, 0x81, 0x7f, 0xff, 0xc0, 0xbf, 0xff, 0xe0, 0xb, 0xff, 0xfe, 0x0,
					   0x1f, 0xc0, 0x2, 0xff, 0xff, 0x81, 0x7f, 0xff, 0xc0, 0xbf, 0xff, 0xe0, 0xb, 0xff, 0xfc, 0x0, 0x1f, 0xc0, 0x2, 0xfc, 0x7f, 0x81,
					   0x7f, 0xff, 0x80, 0xbf, 0xff, 0xe0, 0xb, 0xfe, 0x0, 0x0, 0x1f, 0xc0, 0x2, 0xf8, 0x3f, 0x81, 0x7f, 0xc0, 0x0, 0xbf, 0xff, 0xc0,
					   0xb, 0xfc, 0x0, 0x0, 0x1f, 0xc0, 0x2, 0xf8, 0x3f, 0x81, 0x7f, 0x80, 0x0, 0xbf, 0xff, 0x80, 0xb, 0xfc, 0x0, 0x0, 0x1f, 0xc0, 0x2,
					   0xf8, 0x3f, 0x81, 0x7f, 0x80, 0x0, 0xbc, 0x7f, 0x0, 0xb, 0xfc, 0x0, 0x0, 0x1f, 0xc0, 0x2, 0xf8, 0x3f, 0x81, 0x7f, 0x80, 0x0,
					   0xb8, 0x3f, 0x80, 0xb, 0xfe, 0x0, 0x0, 0x1f, 0xc0, 0x2, 0xf8, 0x3f, 0x81, 0x7f, 0xc0, 0x0, 0xb8, 0x1f, 0xc0, 0xb, 0xff, 0xfe,
					   0x0, 0x1f, 0xc0, 0x2, 0xf8, 0x3f, 0x81, 0x7f, 0xff, 0xc0, 0xb8, 0xf, 0xe0, 0xb, 0xff, 0xfe, 0x0, 0x1f, 0xc0, 0x2, 0xf8, 0x3f,
					   0x81, 0x7f, 0xff, 0xc0, 0xb8, 0x7, 0xe0, 0xf, 0xff, 0xfe, 0x0, 0x1f, 0xc0, 0x3, 0xf8, 0x3f, 0x81, 0xff, 0xff, 0xc0, 0xf8, 0x3,
					   0xe0, 0x7, 0xff, 0xfc, 0x0, 0xf, 0x80, 0x1, 0xf8, 0x3f, 0x0, 0xff, 0xff, 0x80, 0x70, 0x1, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
					   0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
					   0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
					   0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0x0, 0x0,
					   0x0, 0x0, 0x0, 0x0, 0x4, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x22, 0x0, 0x4,0xcc,
					   0x40, 0x8, 0x4, 0x10, 0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x32, 0x4a, 0xaa, 0x44, 0xa1, 0x85, 0x6e, 0xa8, 0x20, 0x0, 0x0,
					   0x0, 0x0, 0x0, 0x0, 0x4, 0x2a, 0xaa, 0xae, 0x44, 0xe1, 0x4d, 0x84, 0x38, 0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x26, 0xaa,
					   0xa8, 0x44, 0x81, 0x95, 0x4, 0xa0, 0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x22, 0x4e, 0x46, 0xee, 0x61, 0xd, 0x2, 0x98, 0x20,
					   0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xff, 0xff,
					   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
					   0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xff, 0xff, 0xff,
					   0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x20, 0x0, 0x0,
					   0x0, 0x0, 0x0, 0x0, 0x5, 0x88, 0x4, 0x10, 0x32, 0x0, 0x23, 0x20, 0x9, 0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x5, 0x45, 0x6e, 0xa8,
					   0x41, 0x55, 0x55, 0x15, 0x8a, 0xa0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x5, 0x8d, 0x84, 0x38, 0x23, 0x55, 0x73, 0x36, 0x3b, 0xa0,
					   0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x5, 0x15, 0x4, 0xa0, 0x15, 0x55, 0x41, 0x54, 0x2a, 0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x5, 0xd,
					   0x2, 0x98, 0x63, 0x72, 0x36, 0x34, 0x19, 0xa0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x20,
					   0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
					   0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
					   0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x0, 0x0,
					   0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x0, 0x0, 0x3, 0x0, 0x10, 0x40, 0x0, 0x0, 0x20, 0x0, 0x0,
					   0x0, 0x0, 0x0, 0x0, 0x4, 0x0, 0x0, 0x4, 0x25, 0xba, 0xa0, 0x0, 0x0, 0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x0, 0x0, 0x2, 0x56,
					   0x10, 0xe0, 0x0, 0x0, 0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x0, 0x0, 0x1, 0x54, 0x12, 0x80, 0x0, 0x0, 0x20, 0x0, 0x0, 0x0,
					   0x0, 0x0, 0x0, 0x4, 0x0, 0x0, 0x6, 0x24, 0xa, 0x60, 0x0, 0x0, 0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x0, 0x0, 0x0, 0x0, 0x0,
					   0x0, 0x0, 0x0, 0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0x0, 0x0, 0x0, 0x0,
					   0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
					   0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
					   0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};
	ML_bmp_or(CUC fond_ecran,0,0,128,64);
}

#pragma section _BR_Size
unsigned long BR_Size;
#pragma section 

#pragma section _TOP

int InitializeSystem(int isAppli, unsigned short OptionNum)
{ 
	return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section